/* Quick test to see if March 12 "is_dst" or not*/
/* author: Powell Hazzard (HP) */

#include <stdio.h>
#include <time.h>
#include <string.h>
#include <stdlib.h>

extern char *tzname[];
extern long int timezone;
extern int daylight;

main()
{
 time_t rawtime;
  struct tm *timeinfo;
  int baselinejul20, baselinefeb4;

  /* get current timeinfo and modify it to user's choice */
  time ( &rawtime );
  timeinfo = localtime ( &rawtime );
  timeinfo->tm_year = 2007 - 1900;
  timeinfo->tm_mon = 07 - 1;
  timeinfo->tm_mday = 20;

  /* call mktime: timeinfo->tm_wday will be set */
  mktime ( timeinfo );
  /*printf(" july 20 time: %s",asctime(timeinfo)); */
  /*printf("name %d\n", timeinfo->tm_isdst); */

  baselinejul20 = timeinfo->tm_isdst;

  timeinfo->tm_mon = 02 - 1;
  timeinfo->tm_mday = 4;
  mktime(timeinfo);
  /*printf(" Feb 4 time: %s %s",asctime(timeinfo),baselinejul20); */

  /*printf("name %d\n", timeinfo->tm_isdst); */

  baselinefeb4 = timeinfo->tm_isdst;


  timeinfo->tm_mon = 03 - 1;
  timeinfo->tm_mday = 12;
  mktime(timeinfo);
  /*printf("Mar 12 time: %s",asctime(timeinfo)); */
  /*printf("name %d\n", timeinfo->tm_isdst); */


  if (timeinfo->tm_isdst == baselinejul20)
        printf("OS Test Passed\n"),exit(0);

  if (timeinfo->tm_isdst == baselinefeb4) {
        timeinfo->tm_mon = 04 - 1;
        timeinfo->tm_mday = 27;
	mktime(timeinfo);
        if (timeinfo->tm_isdst == baselinefeb4)
                printf("Daylight saving not implemented\n"),exit(0);
  }

  printf("OS Test Failed: Please apply the proper OS level patch\n"),exit(1);
}


